options ls=80;

data data;
infile '\T10_1_hematology.txt';
input x1 x2 x3 y x4 x5;
run;

/***************** Example 10.5 ********************/
proc iml;
use data;
read all var {x1 x2 x3 x4 x5} into w;
read all var {y} into y;

n = nrow(w);
k = ncol(w);
w_center = (i(n) - (1/n)*j(n,n)) * w;
wbar = (1/n) * w` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sww = (w_center` * w_center) / (n-1);
syw = (w_center` * y) / (n-1);
swy = syw`;

beta1 = inv(Sww) * syw;
beta0 = ybar - syw` * inv(Sww) * wbar;

*print Sww;
*print syw;
*print swy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syw` * inv(Sww) * syw;
*print 's2 as in (10.17):';
*print s2;

spart1 = syw||Sww;
spart2 = syy||swy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dw = sqrt(diag(Sww));
Rww = inv(Dw)*Sww*inv(Dw);
*print Rww;

sy = sqrt(syy);
ryw = inv(Dw)*syw/sy;
*print ryw;

b1star = inv(Rww)*ryw;
*print b1star;

R2yw = syw` * inv(Sww) * syw / syy;

print R2yw;

quit;


*R2yx;

proc iml;
use data;
read all var {x2 x3 x4 x5} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;

*print ybar;
beta0sub = syx` * inv(Sxx) * xbar;
*print beta0sub;

*print Sxx;
*print syx;
*print sxy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syx` * inv(Sxx) * syx;
*print 's2 as in (10.17):';
*print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;
*print ryx;

b1star = inv(Rxx)*ryx;
*print b1star;

R2yx = syx` * inv(Sxx) * syx / syy;
print 'R2yx for x1(hemo):';
print R2yx;

quit;


proc iml;
use data;
read all var {x1 x3 x4 x5} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;

*print ybar;
beta0sub = syx` * inv(Sxx) * xbar;
*print beta0sub;

*print Sxx;
*print syx;
*print sxy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syx` * inv(Sxx) * syx;
*print 's2 as in (10.17):';
*print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;
*print ryx;

b1star = inv(Rxx)*ryx;
*print b1star;

R2yx = syx` * inv(Sxx) * syx / syy;
print 'R2yx for x2(pcv):';
print R2yx;

quit;


proc iml;
use data;
read all var {x1 x2 x4 x5} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;
*print ybar;
beta0sub = syx` * inv(Sxx) * xbar;
*print beta0sub;

*print Sxx;
*print syx;
*print sxy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syx` * inv(Sxx) * syx;
*print 's2 as in (10.17):';
*print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;
*print ryx;

b1star = inv(Rxx)*ryx;
*print b1star;

R2yx = syx` * inv(Sxx) * syx / syy;
print 'R2yx for x3(pcv):';
print R2yx;

quit;

proc iml;
use data;
read all var {x1 x2 x3 x5} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;
*print ybar;
beta0sub = syx` * inv(Sxx) * xbar;
*print beta0sub;

*print Sxx;
*print syx;
*print sxy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syx` * inv(Sxx) * syx;
*print 's2 as in (10.17):';
*print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;
*print ryx;

b1star = inv(Rxx)*ryx;
*print b1star;

R2yx = syx` * inv(Sxx) * syx / syy;
print 'R2yx for x4(neutro):';
print R2yx;

quit;


proc iml;
use data;
read all var {x1 x2 x3 x4} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;
*print ybar;
beta0sub = syx` * inv(Sxx) * xbar;
*print beta0sub;

*print Sxx;
*print syx;
*print sxy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syx` * inv(Sxx) * syx;
*print 's2 as in (10.17):';
*print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;
*print ryx;

b1star = inv(Rxx)*ryx;
*print b1star;

R2yx = syx` * inv(Sxx) * syx / syy;
print 'R2yx for x5(lead):';
print R2yx;

quit;


*R2zx;

proc iml;
use data;
read all var {x2 x3 x4 x5} into x;
read all var {x1} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
print 'R2zx for x1(hemo):';
print R2zx;
quit;


proc iml;
use data;
read all var {x1 x3 x4 x5} into x;
read all var {x2} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
print 'R2zx for x2(pcv):';
print R2zx;
quit;


proc iml;
use data;
read all var {x1 x2 x4 x5} into x;
read all var {x3} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
print 'R2zx for x3(wbc):';
print R2zx;
quit;


proc iml;
use data;
read all var {x1 x2 x3 x5} into x;
read all var {x4} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
print 'R2zx for x4(neutro):';
print R2zx;
quit;


proc iml;
use data;
read all var {x1 x2 x3 x4} into x;
read all var {x5} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
print 'R2zx for x5(lead):';
print R2zx;
quit;


*ryz;

proc iml;
use data;
read all var {x1} into z;
read all var {y} into y;

n = nrow(z);
k = ncol(z);
z_center = (i(n) - (1/n)*j(n,n)) * z;
zbar = (1/n) * z` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Szz = (z_center` * z_center) / (n-1);
syz = (z_center` * y) / (n-1);
szy = syz`;

beta1 = inv(Szz) * syz;
beta0 = ybar - syz` * inv(Szz) * zbar;

*print Szz;
*print syz;
*print szy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syz` * inv(Szz) * syz;
*print 's2 as in (10.17):';
*print s2;

spart1 = syz||Szz;
spart2 = syy||szy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dz = sqrt(diag(Szz));
Rzz = inv(Dz)*Szz*inv(Dz);
*print Rzz;

sy = sqrt(syy);
ryz = inv(Dz)*syz/sy;
*print ryz;

b1star = inv(Rzz)*ryz;
*print b1star;

ryzs = syz` * inv(Szz) * syz / syy;
print 'simple ryz for x1(hemo):';
print ryzs;

quit;


proc iml;
use data;
read all var {x2} into z;
read all var {y} into y;

n = nrow(z);
k = ncol(z);
z_center = (i(n) - (1/n)*j(n,n)) * z;
zbar = (1/n) * z` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Szz = (z_center` * z_center) / (n-1);
syz = (z_center` * y) / (n-1);
szy = syz`;

beta1 = inv(Szz) * syz;
beta0 = ybar - syz` * inv(Szz) * zbar;

*print Szz;
*print syz;
*print szy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syz` * inv(Szz) * syz;
*print 's2 as in (10.17):';
*print s2;

spart1 = syz||Szz;
spart2 = syy||szy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dz = sqrt(diag(Szz));
Rzz = inv(Dz)*Szz*inv(Dz);
*print Rzz;

sy = sqrt(syy);
ryz = inv(Dz)*syz/sy;
*print ryz;

b1star = inv(Rzz)*ryz;
*print b1star;

ryzs = syz` * inv(Szz) * syz / syy;
print 'simple ryz for x2(pcv):';
print ryzs;

quit;


proc iml;
use data;
read all var {x3} into z;
read all var {y} into y;

n = nrow(z);
k = ncol(z);
z_center = (i(n) - (1/n)*j(n,n)) * z;
zbar = (1/n) * z` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Szz = (z_center` * z_center) / (n-1);
syz = (z_center` * y) / (n-1);
szy = syz`;

beta1 = inv(Szz) * syz;
beta0 = ybar - syz` * inv(Szz) * zbar;

*print Szz;
*print syz;
*print szy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syz` * inv(Szz) * syz;
*print 's2 as in (10.17):';
*print s2;

spart1 = syz||Szz;
spart2 = syy||szy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dz = sqrt(diag(Szz));
Rzz = inv(Dz)*Szz*inv(Dz);
*print Rzz;

sy = sqrt(syy);
ryz = inv(Dz)*syz/sy;
*print ryz;

b1star = inv(Rzz)*ryz;
*print b1star;

ryzs = syz` * inv(Szz) * syz / syy;
print 'simple ryz for x3(wbc):';
print ryzs;

quit;


proc iml;
use data;
read all var {x4} into z;
read all var {y} into y;

n = nrow(z);
k = ncol(z);
z_center = (i(n) - (1/n)*j(n,n)) * z;
zbar = (1/n) * z` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Szz = (z_center` * z_center) / (n-1);
syz = (z_center` * y) / (n-1);
szy = syz`;

beta1 = inv(Szz) * syz;
beta0 = ybar - syz` * inv(Szz) * zbar;

*print Szz;
*print syz;
*print szy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syz` * inv(Szz) * syz;
*print 's2 as in (10.17):';
*print s2;

spart1 = syz||Szz;
spart2 = syy||szy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dz = sqrt(diag(Szz));
Rzz = inv(Dz)*Szz*inv(Dz);
*print Rzz;

sy = sqrt(syy);
ryz = inv(Dz)*syz/sy;
*print ryz;

b1star = inv(Rzz)*ryz;
*print b1star;

ryzs = syz` * inv(Szz) * syz / syy;
print 'simple ryz for x4(neutro):';
print ryzs;

quit;


proc iml;
use data;
read all var {x5} into z;
read all var {y} into y;

n = nrow(z);
k = ncol(z);
z_center = (i(n) - (1/n)*j(n,n)) * z;
zbar = (1/n) * z` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Szz = (z_center` * z_center) / (n-1);
syz = (z_center` * y) / (n-1);
szy = syz`;

beta1 = inv(Szz) * syz;
beta0 = ybar - syz` * inv(Szz) * zbar;

*print Szz;
*print syz;
*print szy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syz` * inv(Szz) * syz;
*print 's2 as in (10.17):';
*print s2;

spart1 = syz||Szz;
spart2 = syy||szy;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dz = sqrt(diag(Szz));
Rzz = inv(Dz)*Szz*inv(Dz);
*print Rzz;

sy = sqrt(syy);
ryz = inv(Dz)*syz/sy;
*print ryz;

b1star = inv(Rzz)*ryz;
*print b1star;

ryzs = syz` * inv(Szz) * syz / syy;
print 'simple ryz for x5(lead):';
print ryzs;

quit;



*ryzhat;

proc iml;
use data;
read all var {x2 x3 x4 x5} into x;
read all var {x1} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
*print 'R2zx for x1(hemo):';
*print R2zx;

read all var {y} into y;
ybar = (1/n) * y` * j(n,1);
syx = (x_center` * y) / (n-1);
sxy = syx`;
syy = (y - ybar)`*(y - ybar) / (n - 1);
sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;

bstarzx = inv(Rxx) * rzx;
ryzhat = bstarzx` * ryx;

print 'ryzhat for x1(hemo):';
print ryzhat;

quit;


proc iml;
use data;
read all var {x1 x3 x4 x5} into x;
read all var {x2} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
*print 'R2zx for x2(pcv):';
*print R2zx;

read all var {y} into y;
ybar = (1/n) * y` * j(n,1);
syx = (x_center` * y) / (n-1);
sxy = syx`;
syy = (y - ybar)`*(y - ybar) / (n - 1);
sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;

bstarzx = inv(Rxx) * rzx;
ryzhat = bstarzx` * ryx;

print 'ryzhat for x2(pcv):';
print ryzhat;

quit;


proc iml;
use data;
read all var {x1 x2 x4 x5} into x;
read all var {x3} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
*print 'R2zx for x3(wbc):';
*print R2zx;

read all var {y} into y;
ybar = (1/n) * y` * j(n,1);
syx = (x_center` * y) / (n-1);
sxy = syx`;
syy = (y - ybar)`*(y - ybar) / (n - 1);
sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;

bstarzx = inv(Rxx) * rzx;
ryzhat = bstarzx` * ryx;

print 'ryzhat for x3(wbc):';
print ryzhat;

quit;


proc iml;
use data;
read all var {x1 x2 x3 x5} into x;
read all var {x4} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
*print 'R2zx for x4(neutro):';
*print R2zx;

read all var {y} into y;
ybar = (1/n) * y` * j(n,1);
syx = (x_center` * y) / (n-1);
sxy = syx`;
syy = (y - ybar)`*(y - ybar) / (n - 1);
sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;

bstarzx = inv(Rxx) * rzx;
ryzhat = bstarzx` * ryx;

print 'ryzhat for x4(neutro):';
print ryzhat;
quit;


proc iml;
use data;
read all var {x1 x2 x3 x4} into x;
read all var {x5} into z;
n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
zbar = (1/n) * z` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
szx = (x_center` * z) / (n-1);
sxz = szx`;

beta1 = inv(Sxx) * szx;
beta0 = zbar - szx` * inv(Sxx) * xbar;

*print Sxx;
*print szx;
*print sxz;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

szz = (z - zbar)`*(z - zbar) / (n - 1);

*print szz;


s2 = szz - szx` * inv(Sxx) * szx;
*print 's2 as in (10.17):';
*print s2;

spart1 = szx||Sxx;
spart2 = szz||sxz;
S = spart2//spart1;
*print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
*print 'R as in (10.18):';
*print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
*print Rxx;

sz = sqrt(szz);
rzx = inv(Dx)*szx/sz;
*print rzx;

b1star = inv(Rxx)*rzx;
*print b1star;

R2zx = szx` * inv(Sxx) * szx / szz;
*print 'R2zx for x5(lead):';
*print R2zx;

read all var {y} into y;
ybar = (1/n) * y` * j(n,1);
syx = (x_center` * y) / (n-1);
sxy = syx`;
syy = (y - ybar)`*(y - ybar) / (n - 1);
sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;

bstarzx = inv(Rxx) * rzx;
ryzhat = bstarzx` * ryx;

print 'ryzhat for x5(lead):';
print ryzhat;

quit;

proc iml;
fval = 0.4094;
pval = 1 - probf(fval,1,45);
print 'p-value for x1:';
print fval;
print pval;

proc iml;
fval = 1.2865;
pval = 1 - probf(fval,1,45);
print 'p-value for x2:';
print fval;
print pval;

proc iml;
fval = 507.72;
pval = 1 - probf(fval,1,45);
print 'p-value for x3:';
print fval;
print pval;

proc iml;
fval = 175.15;
pval = 1 - probf(fval,1,45);
print 'p-value for x4:';
print fval;
print pval;

proc iml;
fval = 0.05848;
pval = 1 - probf(fval,1,45);
print 'p-value for x5:';
print fval;
print pval;

quit;
