options ls=80;

data data;
infile '\T10_1_hematology.txt' firstobs=2;
input x1 x2 x3 y x4 x5;
run;

/**************** Example 10.7 *****************/

proc iml;
use data;
read all var {x1 x2 x3 x4 x5} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;

print Sxx;
print syx;
print sxy;

print 'beta1 as in (10.15):';
print beta1;
print 'beta0 as in (10.16):';
print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

print syy;


s2 = syy - syx` * inv(Sxx) * syx;
print 's2 as in (10.17):';
print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
print S;

Sy1 = S[1:2,1:2];
print Sy1;

Syx1 = S[1:2,3:6];
Sxy1 = S[3:6,1:2];
Sxx1 = S[3:6,3:6];

Ds1 = (diag(Sy1 - Syx1*inv(Sxx1)*Sxy1))##.5;
print Ds1;
print 'ry1.2345 comes from:';
ry1_2345 = inv(Ds1)*(Sy1 - Syx1*inv(Sxx1)*Sxy1)*inv(Ds1);
print ry1_2345;



Sy2 = S[{1 3},{1 3}];
print Sy2;

Syx2 = S[{1 3},{2 4 5 6}];
Sxy2 = S[{2 4 5 6},{1 3}];
Sxx2 = S[{2 4 5 6},{2 4 5 6}];

Ds2 = (diag(Sy2 - Syx2*inv(Sxx2)*Sxy2))##.5;
print Ds2;
print 'ry2.1345 comes from:';
ry2_1345 = inv(Ds2)*(Sy2 - Syx2*inv(Sxx2)*Sxy2)*inv(Ds2);
print ry2_1345;



Sy3 = S[{1 2 3 4},{1 2 3 4}];
print Sy3;

Syx3 = S[{1 2 3 4},{5 6}];
Sxy3 = S[{5 6},{1 2 3 4}];
Sxx3 = S[{5 6},{5 6}];

Ds3 = (diag(Sy3 - Syx3*inv(Sxx3)*Sxy3))##.5;
print Ds3;
print 'ry3.45 comes from:';
ry3_45 = inv(Ds3)*(Sy3 - Syx3*inv(Sxx3)*Sxy3)*inv(Ds3);
print ry3_45;

quit;
