options ls=80;

data data;
infile '\T10_1_hematology.txt' firstobs=2 ;
input x1 x2 x3 y x4 x5;
run;

/************* Example 10.2b ********************/

proc iml;
use data;
read all var {x1 x2 x3 x4 x5} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;
print ybar;
print xbar;
beta0sub = syx` * inv(Sxx) * xbar;
print beta0sub;

print Sxx;
print syx;
print sxy;

print 'beta1 as in (10.15):';
print beta1;
print 'beta0 as in (10.16):';
print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

print syy;

s2 = syy - syx` * inv(Sxx) * syx;
s2sub = syx` * inv(Sxx) * syx;
print s2sub;
print 's2 as in (10.17):';
print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
print S;

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
print 'R as in (10.18):';
print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
print Rxx;

sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;
print ryx;

b1star = inv(Rxx)*ryx;
print b1star;

/************* Example 10.3 ********************/

R2 = syx` * inv(Sxx) * syx / syy;

print R2;

R210_34 = (syx`*inv(Sxx)*syx)/syy;;
print 'R-squared for (10.34):';
print R210_34;

R210_38 = ryx`*inv(Rxx)*ryx;
print 'R-squared for (10.38):';
print R210_38;


/************* Example 10.4a ********************/

F10_4A = (R2/k)/((1-R2)/(n-k-1));
print F10_4A;
p = 1-probf(F10_4A,k,n-k-1);
print p;

quit;
