options ls=80;

data data;
infile '\T12_2_Ascorbic.txt' firstobs=2;
input method $ acid;
if method='A' then method_n = 1;
if method='B' then method_n = 2;
if method='C' then method_n = 3;
run;

/************** Example 12.4.1 ****************/

proc glm;
class method;
model acid = method;
run;

proc iml;
use data;
read var {method_n} into method;
read all var {acid} into y;
x1 = y[{1 2 3 4 5 6 7},];
x2 = y[{8 9 10 11 12 13 14},];
x3 = y[{15 16 17 18 19 20 21},];
x = x1||x2||x3;
totals = j(1,7,1)*x;
means = totals/7;
print totals means;
;
*       find the ys;
;
ydotdot2 = (totals*j(3,1,1))*(totals*j(3,1,1))/21;
print "ydotdot squared divided by kn:";
print ydotdot2;
yidot2 = (totals*totals`)/7;
print "yidot squared divided by number of groups:";
print yidot2;
yij2 = j(1,3,1)*vecdiag(x`*x);
print "sum of yij squared:";
print yij2;
;
ssagmu = yidot2 - ydotdot2;
sse = yij2 - yidot2;
sstot = yij2 - ydotdot2;
print ssagmu sse sstot;
;
ms = ssagmu/2;
mse = sse/18;
F = ms/mse;
print ms mse;
print F;
p = 1-probf(F,2,18);
print p;

quit;

/**************** Example 12.6.2a **************************/

proc glm;
class method;
model acid = method;
contrast "1 vs. 2 & 3" method -2 1 1;
contrast "2 vs. 3" method 0 -1 1;
run;

proc iml;
use data;
read all var {method_n} into levels;
read all var {acid} into y;
k = max(levels);
n = nrow(levels) / k;
x = j(nrow(levels),max(levels));
do i=1 to n*k;
  do j=1 to k;
    x[i,j] = (levels[i,1] = j);
  end;
end;
x = j(n*k,1) || x;
C_all = {0 -2  1  1,
         0  0 -1  1};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / (k*(n-1));
 print mse;

/*** first contrast (0,2,-1,-1) ****/
C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh C;

/*** second contrast (0,0,1,-1) ****/

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh C;

quit;
