options ls=80;

data data;
infile '\T13_2_Cheese.txt' firstobs=2;
input cheese lot moisture;
run;

proc glm;
class cheese lot;
model moisture = cheese lot cheese*lot;
run;

proc iml;
use data;
read all var{cheese} into B;
read all var{lot} into A;
read all var{moisture} into y;
w = {1 0 0 0 0 0,
     1 0 0 0 0 0,
     0 1 0 0 0 0,
     0 1 0 0 0 0,
     0 0 1 0 0 0,
     0 0 1 0 0 0,
     0 0 0 1 0 0,
     0 0 0 1 0 0,
     0 0 0 0 1 0,
     0 0 0 0 1 0,
     0 0 0 0 0 1,
     0 0 0 0 0 1};
cellTp = y`*w;
cellT = cellTp`;
 print 'The total per cell:';
 print cellT;
wa = {1 0,1 0,1 0,0 1,0 1,0 1};
Atot = cellT`*wa;
wb = {1 0 0,0 1 0,0 0 1,1 0 0,0 1 0,0 0 1};
Btot = cellT`*wb;
Tot = cellT`*j(6,1,1);
 print 'The marginal totals:';
 print Atot;
 print Btot;
 print Tot;

Atot = Atot`;
Btot = Btot`;
Tot = Tot`;
Atot2 = Atot`*Atot;
Btot2 = Btot`*Btot;
tot2 = tot`*tot;

SSamubg = (Atot2/6)-(Tot2/12);
Print 'From (13.67):';
print SSamubg;

SSbmuag = (Btot2/4)-(Tot2/12);
Print 'From (13.68):';
print SSbmuag;

SSE = (y`*y)-(cellT`*cellT/2);
Print 'From (13.46):';
print SSE;

SSTot = (y`*y)-(Tot2/12);
print SSTot;

SSgmuab = SSTot-SSamubg-SSbmuag-SSE;
Print 'From (13.45):';
print SSgmuab;

a1=2;b1=3;n1=2;

print 'Table 13.5 F and P values:';
print 'F and p values for Method:';
FA =(SSamubg/(a1-1))/(SSE/(a1*b1*(n1-1)));
print FA;
pFA = 1-probf(FA,(a1-1),(a1*b1*(n1-1)));
print pFA;

print 'F and p values for Type:';
FB =(SSbmuag/(b1-1))/(SSE/(a1*b1*(n1-1)));
print FB;
pFB = 1-probf(FB,(b1-1),(a1*b1*(n1-1)));
print pFB;

print 'F and p values for Interaction:';
FG =(SSgmuab*(a1*b1*(n1-1)))/(SSE*(a1-1)*(b1-1));
print FG;
pFG = 1-probf(FG,(a1-1)*(b1-1),(a1*b1*(n1-1)));
print pFG;

quit;
