options ls=80;

data d1;
infile '\T14_2_Machine.txt' firstobs=2;
input machine fill;
run;

/******************** Example 14.2.1 *****************/

proc glm;
class machine;
model fill = machine;
title 'Unweighted contrasts';
run;

proc iml;
use d1;
read all var{machine} into m;
read all var{fill} into y;
a1=5;n1=4;n2=2;n3=3;n4=3;n5=4;
w = {1 0 0 0 0,
     1 0 0 0 0,
     1 0 0 0 0,
     1 0 0 0 0,
     0 1 0 0 0,
     0 1 0 0 0,
     0 0 1 0 0,
     0 0 1 0 0,
     0 0 1 0 0,
     0 0 0 1 0,
     0 0 0 1 0,
     0 0 0 1 0,
     0 0 0 0 1,
     0 0 0 0 1,
     0 0 0 0 1,
     0 0 0 0 1};
Ap = y`*w;
ATot = Ap`;
Tot = ATot`*j(5,1,1);
 print 'The marginal totals:';
 print Atot;
 print Tot;

Atot = Atot`;
Tot = Tot`;
Atot2 = Atot`*Atot;
tot2 = tot`*tot;
ns = {4 0 0 0 0,
      0 2 0 0 0,
      0 0 3 0 0,
      0 0 0 3 0,
      0 0 0 0 4};
ins = inv(ns);

SSB = Atot*ins*Atot` - (Tot2/16);
print SSB;

SSE = y`*y - Atot*ins*Atot`;
print SSE;

print 'Table 14.3 F and P values:';
print 'F and p values for Machine:';
F =(SSB/(a1-1))/(SSE/(16-a1));
print F;
pF = 1-probf(F,(a1-1),(16-a1));
print pF;

quit;

/******************** Example 14.2.2b *****************/

proc glm;
class machine;
model fill = machine;
contrast 'A,D vs. B,C,E' machine 3 -2 -2 3 -2;
contrast 'B,E vs. C' machine 0 1 -2 0 1;
contrast 'A vs. D' machine 1 0 0 -1 0;
contrast 'B vs. E' machine 0 1 0 0 -1;
title 'Unweighted contrasts';
run;

proc glm;
class machine;
model fill = machine;
contrast 'A,D vs. B,C,E' machine 3 -2 -2 3 -2;
contrast 'B,E vs. C' machine 0 2 -6 0 4;
title 'Weighted Contrasts';
run;


proc iml;
use d1;
read all var{machine} into m;
read all var{fill} into y;
k=5;n1=4;n2=2;n3=3;n4=3;n5=4;
w = {1 0 0 0 0,
     1 0 0 0 0,
     1 0 0 0 0,
     1 0 0 0 0,
     0 1 0 0 0,
     0 1 0 0 0,
     0 0 1 0 0,
     0 0 1 0 0,
     0 0 1 0 0,
     0 0 0 1 0,
     0 0 0 1 0,
     0 0 0 1 0,
     0 0 0 0 1,
     0 0 0 0 1,
     0 0 0 0 1,
     0 0 0 0 1};
x = j(16,1) || w;
C_all = {0  3 -2 -2  3 -2,
         0  0  1 -2  0  1,
         0  1  0  0 -1  0,
         0  0  1  0  0 -1};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / ((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1));

print mse;
print 'Unweighted Contrasts:';

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[3,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[4,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

print 'Weighted Contrasts:';
C_all = {0  3 -2 -2  3 -2,
         0  0  2 -6  0  4};

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

quit;
