options ls=80;

data d1;
infile '\T15_2_Guppy.txt' firstobs=2;
input group initial matur;
run;

proc iml;
use d1;
read all var{matur} into y;
read all var{initial} into x;
z1 = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
z2 = {1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
z3 = {0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0};
z4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1};
Z = z1||z2||z3||z4;
P = Z*(ginv(Z`*Z))*Z`;
n = nrow(Z);
Exx = X`*(I(n)-P)*X;
exy = X`*(I(n)-P)*y;
B = (inv(Exx))*exy;
a0 = (ginv(Z`*Z))*Z`*y;
a = a0-(ginv(Z`*Z))*Z`*X*B;
SSEy = y`*y-a0`*Z`*y;
SSEyx = SSEy-B`*X`*(I(n)-P)*y;
SSH = exy`*(inv(Exx))*exy;
eyy = y`*(I(n)-P)*y;
betahat = exy/exx;
SSy = y`*(I(n)-(1/n)*J(n))*y;
SSx = X`*(I(n)-(1/n)*J(n))*X;
SSxy = X`*(I(n)-(1/n)*J(n))*y;
SSErd = SSy - (SSxy##2)/SSx;
SSagivub = SSErd - SSEyx;
k = 3; *number of groups;
n1 = 7; *number in each group;
F = (SSagivub*(k*(n1-1)-1))/(SSEyx*(k-1));
SSTyx = SSagivub + SSEyx;
Fforbeta = ((exy##2)*(k*(n1-1)-1))/(SSEyx*exx);

y1 = y[{1,2,3,4,5,6,7},];
X1 = X[{1,2,3,4,5,6,7},];
Z11 = {1,1,1,1,1,1,1};
P11 = Z11*(ginv(Z11`*Z11))*Z11`;
n11 = nrow(Z11);
Exx1 = X1`*(I(n11)-(1/n11)*J(n11))*X1;
exy1 = X1`*(I(n11)-(1/n11)*J(n11))*y1;
b1 = inv(exx1)*exy1;

y2 = y[{8,9,10,11,12,13,14},];
X2 = X[{8,9,10,11,12,13,14},];
Z22 = {1,1,1,1,1,1,1};
P22 = Z22*(ginv(Z22`*Z22))*Z22`;
n22 = nrow(Z22);
Exx2 = X2`*(I(n22)-(1/n11)*J(n11))*X2;
exy2 = X2`*(I(n22)-(1/n11)*J(n11))*y2;
b2 = inv(exx2)*exy2;

y3 = y[{15,16,17,18,19,20,21},];
X3 = X[{15,16,17,18,19,20,21},];
Z33 = {1,1,1,1,1,1,1};
P33 = Z33*(ginv(Z33`*Z33))*Z33`;
n33 = nrow(Z33);
Exx3 = X3`*(I(n33)-(1/n11)*J(n11))*X3;
exy3 = X3`*(I(n33)-(1/n11)*J(n11))*y3;
b3 = inv(exx3)*exy3;

SSEFyx = eyy-(((exy1##2)/Exx1)+((exy2##2)/Exx2)+
((exy3##2)/Exx3));
sum1 = (exy1##2)/Exx1;
sum2 = exy2##2/Exx2;
sum3 = exy3##2/Exx3;


SSERyx = eyy - (exy##2)/exx;
SSbtest = SSERyx - SSEFyx;
Fbtest = (SSbtest*k*(n1-2))/(SSEFyx*(k-1));

title 'proc iml output';
print 'Exx exy and eyy from (15.25)';
 print Exx exy eyy;
print 'beta estimator from (15.26)';
 print betahat;
print 'SSEyx from (15.27)';
 print SSEyx;
print 'SS(alpha given mu,beta) from (15.30)';
 print SSagivub;
print 'test statistic for alpha equivalence from (15.31)';
 print F;
print 'Table 15.1 on page 464 (treatments,error,total)';
 dftreat = k-1;
 dferror = k*(n1-1)-1;
 dftotal = k*n1-2;
 print SSagivub dftreat;
 print SSEyx dferror;
 print SSTyx dftotal;
print 'test statistic F for beta = 0';
 print Fforbeta;
print 'betas from (15.45)';
 print b1 b2 b3;
print 'test for equivalence of betas in (15.46)-(15.49)';
 print SSEFyx;
 print SSERyx;
 print SSbtest;
 print Fbtest;

quit;
