options ls=80;

data rate;
infile '\T15_7_Ratings.txt' firstobs=2;
input course y x1 x2;
run;

/***************** Example 15.5.3 *************************/

proc iml;
use rate;
read all var {course} into course;
read all var {y} into y;
read all var {x1} into x1;
read all var {x2} into x2;

*find exx;
x = x1||x2;
  z1 = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
  z2 = {1,1,1,1,1,0,0,0,0,0,0,0,0,0,0};
  z3 = {0,0,0,0,0,1,1,1,1,1,0,0,0,0,0};
  z4 = {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1};
 Z = z1||z2||z3||z4;
 P = Z*(ginv(Z`*Z))*Z`;
 n = nrow(Z);
exx = x`*(I(n)-P)*x;
exy = x`*(I(n)-P)*y;
 B = (inv(exx))*exy;
 a0 = (ginv(Z`*Z))*Z`*y;
 a = a0-(ginv(Z`*Z))*Z`*X*B;
eyy = y`*y-a0`*Z`*y;
print 'From (15.67), (15.68), and (15.69):';
print exx exy eyy;
print 'Beta from (15.15):';
print B;
;
*sseyx and sstyx;
sseyx = eyy - exy`*inv(exx)*exy;
 txx = x`*(I(n)-(j(n,n,1)/n))*x;
 txy = x`*(I(n)-(j(n,n,1)/n))*y;
 tyy = y`*(I(n)-(j(n,n,1)/n))*y;
sstyx = tyy - txy`*inv(txx)*txy;
ssamb = sstyx-sseyx;
print 'From (15.77), (15.81), and (15.82):';
print sseyx sstyx ssamb;
;
print 'test for main effect (15.83):';
fnum = ssamb/2;
fdenom = sseyx/10;
f = fnum/fdenom;
print f;
p = 1-probf(f,2,10);
print p;
;
*to test Ho:beta=0;
;
print 'F for homogeneity of slopes (15.84):';
fnum = exy`*inv(exx)*exy/2;
fdenom = sseyx/10;
f=fnum/fdenom;
print f;
p = 1-probf(f,2,10);
print p;
;
*to test homogeneity of slope vectors;
;
print 'To test for homogeneity of slope vectors:';

y1c = y[{1 2 3 4 5},];
y2c = y[{6 7 8 9 10},];
y3c = y[{11 12 13 14 15},];
x1c1 = x1[{1 2 3 4 5},];
x2c1 = x1[{6 7 8 9 10},];
x3c1 = x1[{11 12 13 14 15},];
x1c2 = x2[{1 2 3 4 5},];
x2c2 = x2[{6 7 8 9 10},];
x3c2 = x2[{11 12 13 14 15},];
x1c = x1c1||x1c2;
x2c = x2c1||x2c2;
x3c = x3c1||x3c2;
n=5;
 exx1 = x1c`*(I(n)-(j(n,n,1)/n))*x1c;
 exy1 = x1c`*(I(n)-(j(n,n,1)/n))*y1c;
 exx2 = x2c`*(I(n)-(j(n,n,1)/n))*x2c;
 exy2 = x2c`*(I(n)-(j(n,n,1)/n))*y2c;
 exx3 = x3c`*(I(n)-(j(n,n,1)/n))*x3c;
 exy3 = x3c`*(I(n)-(j(n,n,1)/n))*y3c;
print exx1 exy1;
print exx2 exy2;
print exx3 exy3;
beta1 = inv(exx1)*exy1;
beta2 = inv(exx2)*exy2;
beta3 = inv(exx3)*exy3;
print 'Betas using (15.88):';
print beta1 beta2 beta3;
;
*f test;
ssefyx = eyy - exy1`*inv(exx1)*exy1
             - exy2`*inv(exx2)*exy2
             - exy3`*inv(exx3)*exy3;
sseryx = eyy -exy`*inv(exx)*exy;
fnum = (sseryx - ssefyx)/4;
fdenom = ssefyx/6;
f = fnum/fdenom;
print 'By (15.86) and (15.87):';
print ssefyx sseryx;
print 'F to test homogeneity of slope vectors:';
print f;
p = 1-probf(f,2,10);
print p;
quit;
