options ls=80;

data data;
infile '\T10_2_rat.txt' firstobs=2;
input x1 x2 x3 y;
run;

/**************** Problem 10.27 *******************/

proc iml;
use data;
read all var {x1 x2 x3} into x;
read all var {y} into y;

/*** part a ***/

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;

print Sxx;
print syx;
print sxy;

print 'beta1 as in (10.15):';
print beta1;
print 'beta0 as in (10.16):';
print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

print syy;

s2 = syy - syx` * inv(Sxx) * syx;
print 's2 as in (10.17):';
print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
print S;

/*** part b ***/

Ds = sqrt(diag(S));
R = inv(Ds)*S*inv(Ds);
print 'R as in (10.18):';
print R;

Dx = sqrt(diag(Sxx));
Rxx = inv(Dx)*Sxx*inv(Dx);
print Rxx;

sy = sqrt(syy);
ryx = inv(Dx)*syx/sy;
print ryx;

b1star = inv(Rxx)*ryx;
print b1star;

/*** part c ***/

R2 = syx` * inv(Sxx) * syx / syy;

print R2;

R210_34 = syx`*inv(sxx)*syx/syy;
print 'R-squared for (10.34):';
print R210_34;

R210_38 = ryx`*inv(Rxx)*ryx;
print 'R-squared for (10.38):';
print R210_38;

/*** part d ***/

F = (R2/k)/((1-R2)/(n-k-1));
print F;
p = 1 - probf(F,k,n-k-1);
print p;

quit;
