options ls=80;

data data;
infile '\T10_1_HematologySplit.txt' firstobs=2;
input x1 x2 x3 y1 x4 x5 x21 x22 x23 y2 x24 x25;
run;

proc iml;

print 'x1 = hemo, x21 = hemo2';
print 'x2 = pcv, x22 = pcv2';
print 'x3 = wbc, x23 = wbc2';
print 'y1 = lympho, y2 = lympho2';
print 'x4 = neutro, x24 = neutro2';
print 'x5 = lead, x25 = lead2';

/*** part a ***/

print 'Now we examine x2 and x22:';

proc iml;
n2 = 26;
r2 = .59657355;
z2 = (.5) * log((1 + r2) / (1 - r2));
print z2;

n22 = 25;
r22 = .072111025;
z22 = (.5) * log((1 + r22) / (1 - r22));
print z22;

v2 = (z2 - z22) / ((1/(n2-3) + 1/(n22-3))##.5);
print 'v2 from (10.55):';
print v2;

print 'table z for z(.05/2):';
z_25 = 1.96;
print z_25;

x_low2 = z2 - z_25/((n2-3)##.5);
x_hi2 =  z2 + z_25/((n2-3)##.5);

tanhxlo2 = (exp(x_low2) - exp(-x_low2))/((exp(x_low2) + exp(-x_low2)));
tanhxhi2 = (exp(x_hi2) - exp(-x_hi2))/((exp(x_hi2) + exp(-x_hi2)));
print 'The lower and upper confidence limits';
print 'for rho for r2 in (10.57) are:';
print tanhxlo2;
print tanhxhi2;

x_low22 = z22 - z_25/((n22-3)##.5);
x_hi22 =  z22 + z_25/((n22-3)##.5);

tanlo22 = (exp(x_low22) - exp(-x_low22))/((exp(x_low22) + exp(-x_low22)));
tanhi22 = (exp(x_hi22) - exp(-x_hi22))/((exp(x_hi22) + exp(-x_hi22)));
print 'The lower and upper confidence limits';
print 'for rho for r22 in (10.57) are:';
print tanlo22;
print tanhi22;

/*** part b ***/

print 'Now we examine x3 and x33:';

proc iml;
n3 = 26;
r3 = .70121323;
z3 = (.5) * log((1 + r3) / (1 - r3));
print z3;

n33 = 25;
r33 = .82085321;
z33 = (.5) * log((1 + r33) / (1 - r33));
print z33;

v3 = (z3 - z33) / ((1/(n3-3) + 1/(n33-3))##.5);
print 'v3 from (10.55):';
print v3;

print 'table z for z(.05/2):';
z_25 = 1.96;
print z_25;

x_low3 = z3 - z_25/((n3-3)##.5);
x_hi3 =  z3 + z_25/((n3-3)##.5);

tanhxlo3 = (exp(x_low3) - exp(-x_low3))/((exp(x_low3) + exp(-x_low3)));
tanhxhi3 = (exp(x_hi3) - exp(-x_hi3))/((exp(x_hi3) + exp(-x_hi3)));
print 'The lower and upper confidence limits';
print 'for rho for r3 in (10.57) are:';
print tanhxlo3;
print tanhxhi3;

x_low33 = z33 - z_25/((n33-3)##.5);
x_hi33 =  z33 + z_25/((n33-3)##.5);

tanlo33 = (exp(x_low33) - exp(-x_low33))/((exp(x_low33) + exp(-x_low33)));
tanhi33 = (exp(x_hi33) - exp(-x_hi33))/((exp(x_hi33) + exp(-x_hi33)));
print 'The lower and upper confidence limits';
print 'for rho for r33 in (10.57) are:';
print tanlo33;
print tanhi33;

/*** part c ***/

print 'Now we examine x4 and x44:';

proc iml;
n4 = 26;
r4 = .04;
z4 = (.5) * log((1 + r4) / (1 - r4));
print z4;

n44 = 25;
r44 = .07141428;
z44 = (.5) * log((1 + r44) / (1 - r44));
print z44;

v4 = (z4 - z44) / ((1/(n4-3) + 1/(n44-3))##.5);
print 'v4 from (10.55):';
print v4;

print 'table z for z(.05/2):';
z_25 = 1.96;
print z_25;

x_low4 = z4 - z_25/((n4-3)##.5);
x_hi4 =  z4 + z_25/((n4-3)##.5);

tanhxlo4 = (exp(x_low4) - exp(-x_low4))/((exp(x_low4) + exp(-x_low4)));
tanhxhi4 = (exp(x_hi4) - exp(-x_hi4))/((exp(x_hi4) + exp(-x_hi4)));
print 'The lower and upper confidence limits';
print 'for rho for r4 in (10.57) are:';
print tanhxlo4;
print tanhxhi4;

x_low44 = z44 - z_25/((n44-3)##.5);
x_hi44 =  z44 + z_25/((n44-3)##.5);

tanlo44 = (exp(x_low44) - exp(-x_low44))/((exp(x_low44) + exp(-x_low44)));
tanhi44 = (exp(x_hi44) - exp(-x_hi44))/((exp(x_hi44) + exp(-x_hi44)));
print 'The lower and upper confidence limits';
print 'for rho for r44 in (10.57) are:';
print tanlo44;
print tanhi44;

/*** part d ***/

print 'Now we examine x5 and x55';

proc iml;
n5 = 26;
r5 = .3391165;
z5 = (.5) * log((1 + r5) / (1 - r5));
print z5;

n55 = 25;
r55 = .268328157;
z55 = (.5) * log((1 + r55) / (1 - r55));
print z55;

v5 = (z5 - z55) / ((1/(n5-3) + 1/(n55-3))##.5);
print 'v5 from (10.55):';
print v5;

print 'table z for z(.05/2):';
z_25 = 1.96;
print z_25;

x_low5 = z5 - z_25/((n5-3)##.5);
x_hi5 =  z5 + z_25/((n5-3)##.5);

tanhxlo5 = (exp(x_low5) - exp(-x_low5))/((exp(x_low5) + exp(-x_low5)));
tanhxhi5 = (exp(x_hi5) - exp(-x_hi5))/((exp(x_hi5) + exp(-x_hi5)));
print 'The lower and upper confidence limits';
print 'for rho for r5 in (10.57) are:';
print tanhxlo5;
print tanhxhi5;

x_low55 = z55 - z_25/((n55-3)##.5);
x_hi55 =  z55 + z_25/((n55-3)##.5);

tanlo55 = (exp(x_low55) - exp(-x_low55))/((exp(x_low55) + exp(-x_low55)));
tanhi55 = (exp(x_hi55) - exp(-x_hi55))/((exp(x_hi55) + exp(-x_hi55)));
print 'The lower and upper confidence limits';
print 'for rho for r55 in (10.57) are:';
print tanlo55;
print tanhi55;

quit;
