options ls=80;

data data;
infile '\T12_6_BloodSugar.txt' firstobs=2;
input breed $ sugar;
if breed = 'A' then breed_n = 1;
if breed = 'B' then breed_n = 2;
if breed = 'C' then breed_n = 3;
if breed = 'D' then breed_n = 4;
if breed = 'E' then breed_n = 5;
run;

proc glm;
class breed;
model sugar = breed;
contrast 'ABCvDE' breed -2 -2 -2 3 3;
contrast 'ABvC' breed 1 1 -2 0 0;
contrast 'AvB' breed 1 -1 0 0 0;
contrast 'DvE' breed 0 0 0 -1 1;
run;

proc iml;
use data;
read all var {breed_n} into levels;
read all var {sugar} into y;
k = max(levels);
n = nrow(levels) / k;
x = j(nrow(levels),max(levels));
do i=1 to n*k;
  do j=1 to k;
    x[i,j] = (levels[i,1] = j);
  end;
end;
x = j(n*k,1) || x;
C_all = {0 -2 -2 -2  3  3,
         0  1  1 -2  0  0,
         0  1 -1  0  0  0,
         0  0  0  0 -1  1};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / (k*(n-1));

print mse;

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh;
p = 1-probf(F,1,k*(n-1));
print p;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh;
p = 1-probf(F,1,k*(n-1));
print p;

C = C_all[3,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh;
p = 1-probf(F,1,k*(n-1));
print p;

C = C_all[4,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh;
p = 1-probf(F,1,k*(n-1));
print p;

quit;
