options ls=80;

data data;
infile '\T12_7_Insulin.txt' firstobs=2;
input glucose insulin;
run;


/*** part a ***/
proc glm;
class glucose;
model insulin = glucose;
run;

/*** part b ***/

proc glm;
class glucose;
model insulin = glucose;
contrast 'linear' glucose -2 -1 0 1 2;
contrast 'quadratic' glucose 2 -1 -2 -1 2;
contrast 'cubic' glucose -1 2 0 -2 1;
contrast '4th degree' glucose 1 -4 6 -4 1;
run;

proc iml;
use data;
read all var {glucose} into levels;
read all var {insulin} into y;
k = max(levels);
n = nrow(levels) / k;
x = j(nrow(levels),max(levels));
do i=1 to n*k;
  do j=1 to k;
    x[i,j] = (levels[i,1] = j);
  end;
end;
x = j(n*k,1) || x;
C_all = {0 -2 -1  0  1  2,
         0  2 -1 -2 -1  2,
         0 -1  2  0 -2  1,
         0  1 -4  6 -4  1};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / (k*(n-1));

print mse;

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

C = C_all[3,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

C = C_all[4,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

quit;
