options ls=80;

data data;
infile '\T12_8_Stimulus.txt' firstobs=2;
input stimuli response;
run;

/*** part a ***/

proc glm;
class stimuli;
model response = stimuli;
run;

/*** part b ***/

proc glm;
class stimuli;
model response = stimuli;
contrast "1 vs. 2 & 3" stimuli -2 1 1;
contrast "2 vs. 3" stimuli 0 -1 1;
run;

proc iml;
use data;
read all var {stimuli} into levels;
read all var {response} into y;
k = max(levels);
n = nrow(levels) / k;
x = j(nrow(levels),max(levels));
do i=1 to n*k;
  do j=1 to k;
    x[i,j] = (levels[i,1] = j);
  end;
end;
x = j(n*k,1) || x;
C_all = {0 2 -1 -1 ,
         0  0 1 -1 };
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / (k*(n-1));

print mse;

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

quit;
