options ls=80;

data data;
infile '\T12_9_Tensile.txt' firstobs=2;
input cable strength;
run;

proc glm;
class cable;
model strength = cable;
contrast 'Lot A vs. Lot B' cable -5 -5 -5 -5 4 4 4 4 4;
run;


proc iml;
use data;
read all var {cable} into levels;
read all var {strength} into y;
k = max(levels);
n = nrow(levels) / k;
x = j(nrow(levels),max(levels));
do i=1 to n*k;
  do j=1 to k;
    x[i,j] = (levels[i,1] = j);
  end;
end;
x = j(n*k,1) || x;
C_all = {0 -5 -5 -5 -5 4 4 4 4 4};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / (k*(n-1));

print mse;

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

quit;
