options ls=80;

data data;
infile '\T12_10_PhysicalT.txt' firstobs=2;
input trt score;
run;

/*** part a ***/

proc glm;
class trt;
model score = trt;
run;

/*** part b ***/

proc glm;
class trt;
model score = trt;
contrast "12v34" trt -1 -1 1 1;
contrast "1v2" trt -1 1 0 0;
contrast "3v4" trt 0 0 -1 1;
run;

proc iml;
use data;
read all var {trt} into levels;
read all var {score} into y;
k = max(levels);
n = nrow(levels) / k;
x = j(nrow(levels),max(levels));
do i=1 to n*k;
  do j=1 to k;
    x[i,j] = (levels[i,1] = j);
  end;
end;
x = j(n*k,1) || x;
C_all = {0 -1 -1  1  1,
         0 -1  1  0  0,
         0  0  0 -1  1};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / (k*(n-1));

print y x;
print mse;

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh;

C = C_all[3,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh;

quit;
