options ls=80;

data data;
infile '\T12_11_Pigs.txt' firstobs=2;
input lot gain;
run;

proc glm;
class lot;
model gain = lot;
contrast '4th vs. previous' lot -1 -1 -1  3;
contrast '3th vs. previous' lot -1 -1  2;
contrast '2th vs. previous' lot -1  1;
run;


proc iml;
use data;
read all var {lot} into levels;
read all var {gain} into y;
k = max(levels);
n = nrow(levels) / k;
x = j(nrow(levels),max(levels));
do i=1 to n*k;
  do j=1 to k;
    x[i,j] = (levels[i,1] = j);
  end;
end;
x = j(n*k,1) || x;
C_all = {0 -1 -1 -1  3,
         0 -1 -1  2  0,
         0 -1  1  0  0};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / (k*(n-1));

print mse;

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;

C = C_all[3,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;


quit;
