options ls=80;

data data;
infile '\T14_8_Chickwt.txt' firstobs=2;
input source weight;
run;

/*** part a ***/

proc glm;
class source;
model weight = source;
means source;
run;

proc iml;
use data;
read all var{weight} into y;
a1=5;n1=12;n2=14;n3=12;n4=11;n5=12;
w1 = {1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w2 = {0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,
      1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w3 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,
      0,0,0,0,0,0,0,0,0,0,0};
w5 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
      1,1,1,1,1,1,1,1,1,1,1};

W = w1||w2||w3||w4||w5;

Ap = y`*w;
ATot = Ap`;
Tot = ATot`*j(5,1,1);
 print 'The marginal totals:';
 print Atot;
 print Tot;

Atot = Atot`;
Tot = Tot`;
Atot2 = Atot`*Atot;
tot2 = tot`*tot;
ns = {12 0 0 0 0,
      0 14 0 0 0,
      0 0 12 0 0,
      0 0 0 11 0,
      0 0 0 0 12};
ins = inv(ns);

SSB = Atot*ins*Atot` - (Tot2/61);
print SSB;

SSE = y`*y - Atot*ins*Atot`;
print SSE;

print 'Table 14.3 F and P values:';
print 'F and p values for Machine:';
F =(SSB/(a1-1))/(SSE/(61-a1));
print F;
pF = 1-probf(F,(a1-1),(61-a1));
print pF;

quit;

/*** part b ***/

proc glm;
class source;
model weight = source;
contrast 'L,C vs So,Su,M' source 3 -2 -2 -2 3;
contrast 'So,M vs Su' source 0 1 -2 1 0;
contrast 'So vs M' source 0 1 0 -1 0;
contrast 'L vs C' source 1 0 0 0 -1;
run;

proc iml;
use data;
read all var{weight} into y;
a1=5;n1=12;n2=14;n3=12;n4=11;n5=12;
w1 = {1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w2 = {0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,
      1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w3 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,
      0,0,0,0,0,0,0,0,0,0,0};
w5 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
      1,1,1,1,1,1,1,1,1,1,1};
W = w1||w2||w3||w4||w5;

x = j(61,1) || w;
C_all = {0  3 -2 -2 -2  3,
         0  0  1 -2  1  0,
         0  0  1  0 -1  0,
         0  1  0  0  0 -1};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / ((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1));

print mse;
print 'Unweighted Contrasts:';

C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[3,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[4,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

quit;

/*** part c ***/

proc glm;
class source;
model weight = source;
contrast 'L,C vs So,Su,M' source 3 -2 -2 -2 3;
contrast 'So,M vs Su' source 0 7 -18 11 0;
run;

proc iml;
use data;
read all var{weight} into y;
a1=5;n1=12;n2=14;n3=12;n4=11;n5=12;
w1 = {1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w2 = {0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,
      1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w3 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0};
w4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,
      0,0,0,0,0,0,0,0,0,0,0};
w5 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
      1,1,1,1,1,1,1,1,1,1,1};
W = w1||w2||w3||w4||w5;

print 'Weighted Contrasts:';
x = j(61,1) || w;
C_all = {0  3 -2 -2 -2  3,
         0  0  7 -18 11 0};
beta = ginv(x`*x)*x`*y;
mse = (y`*y - beta`*x`*y) / ((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1));


C = C_all[1,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

C = C_all[2,];
ssh = (C*beta)`*inv(C*ginv(x`*x)*C`)*(C*beta);
F = (ssh/nrow(C)) / mse;
print F ssh ;
p = 1-probf(f,nrow(C),((n1-1)+(n2-1)+(n3-1)+(n4-1)+(n5-1)));
print p;

quit;
