options ls=80;

data d1;
infile '\T15_11_Gain.txt' firstobs=2;
input trt age weight gain;
run;

/*** part a ***/

proc iml;
use d1;
read all var{gain} into y;
read all var{age weight} into x;
z1 = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
z2 = {1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
z3 = {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
z4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0};
z5 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1};
Z = z1||z2||z3||z4||z5;
P = Z*(ginv(Z`*Z))*Z`;
n = nrow(Z);
Exx = X`*(I(n)-P)*X;
exy = X`*(I(n)-P)*y;
B = (inv(Exx))*exy;
a0 = (ginv(Z`*Z))*Z`*y;
a = a0-(ginv(Z`*Z))*Z`*X*B;
SSEy = y`*y-a0`*Z`*y;
SSEyx = SSEy-B`*X`*(I(n)-P)*y;
SSH = exy`*(inv(Exx))*exy;
eyy = y`*(I(n)-P)*y;
betahat = (inv(Exx))*exy;

title 'proc iml output';
print 'Exx from (15.67):';
 print Exx;
print 'exy from (15.68):';
 print exy;
print 'eyy from (15.69):';
 print eyy;
print 'beta estimator:';
 print betahat;

/*** part b ***/

SSy = y`*(I(n)-(1/n)*J(n))*y;
SSx = X`*(I(n)-(1/n)*J(n))*X;
SSxy = X`*(I(n)-(1/n)*J(n))*y;
SSErd = SSy - SSxy`*(inv(SSx))*SSxy;
SSagivub = SSErd - SSEyx;
k = 4; *number of groups;
n1 = 10; *number in each group;
Ffora = (SSagivub*(k*(n1-1)-2))/(SSEyx*(k-1));
pFfora = 1-probf(Ffora,k-1,(k*(n1-1)-2));

print 'SSEyx from (15.77):';
 print SSEyx;
print 'alpha estimator for (15.78) and (15.79):';
 print a;
print 'SSErd from (15.81):';
 print SSErd;
print 'SS(alpha given mu,beta) from (15.82):';
 print SSagivub;
print 'test statistic for alpha equivalence from (15.83):';
 print Ffora;
 print pFfora;

/*** part c ***/

SSTyx = SSagivub + SSEyx;
Fforbeta = ((exy`*(inv(Exx))*exy)*(k*(n1-1)-2))/(SSEyx*2);
pFforbeta = 1-probf(Fforbeta,2,(k*(n1-1)-2));

print 'Table (treatments,error,total):';
 dftreat = k-1;
 dferror = k*(n1-1)-2;
 dftotal = k*n1-2-1;
 print SSagivub dftreat;
 print SSEyx dferror;
 print SSTyx dftotal;
print 'test statistic F for beta = 0, (15.84):';
 print Fforbeta;
 print pFforbeta;

/*** part d ***/

y1 = y[{1,2,3,4,5,6,7,8,9,10},];
X1 = X[{1,2,3,4,5,6,7,8,9,10},];
Z11 = {1,1,1,1,1,1,1,1,1,1};
P11 = Z11*(ginv(Z11`*Z11))*Z11`;
n11 = nrow(Z11);
Exx1 = X1`*(I(n11)-(1/n11)*J(n11))*X1;
exy1 = X1`*(I(n11)-(1/n11)*J(n11))*y1;

y2 = y[{11,12,13,14,15,16,17,18,19,20},];
X2 = X[{11,12,13,14,15,16,17,18,19,20},];
Z22 = {1,1,1,1,1,1,1,1,1,1};
P22 = Z22*(ginv(Z22`*Z22))*Z22`;
n22 = nrow(Z22);
Exx2 = X2`*(I(n22)-(1/n11)*J(n11))*X2;
exy2 = X2`*(I(n22)-(1/n11)*J(n11))*y2;

y3 = y[{21,22,23,24,25,26,27,28,29,30},];
X3 = X[{21,22,23,24,25,26,27,28,29,30},];
Z33 = {1,1,1,1,1,1,1,1,1,1};
P33 = Z33*(ginv(Z33`*Z33))*Z33`;
n33 = nrow(Z33);
Exx3 = X3`*(I(n33)-(1/n11)*J(n11))*X3;
exy3 = X3`*(I(n33)-(1/n11)*J(n11))*y3;

y4 = y[{31,32,33,34,35,36,37,38,39,40},];
X4 = X[{31,32,33,34,35,36,37,38,39,40},];
Z44 = {1,1,1,1,1,1,1,1,1,1};
P44 = Z44*(ginv(Z44`*Z44))*Z44`;
n44 = nrow(Z44);
Exx4 = X4`*(I(n44)-(1/n11)*J(n11))*X4;
exy4 = X4`*(I(n44)-(1/n11)*J(n11))*y4;

SSEFyx = eyy-((exy1`*(inv(Exx1))*exy1)+(exy2`*(inv(Exx2))*exy2)
  +(exy3`*(inv(Exx3))*exy3)+(exy4`*(inv(Exx4))*exy4));

SSERyx = eyy - (exy`*(inv(Exx))*exy);
SSbtest = SSERyx - SSEFyx;
Fbtest = (SSbtest*k*(n1-3))/(SSEFyx*2*(k-1));
pFbtest = 1-probf(Fbtest,2*(k-1),k*(n1-3));

print 'Beta estimates using (15.86):';
 print Exx1 exy1;
 print Exx2 exy2;
 print Exx3 exy3;
 print Exx4 exy4;

beta1 = inv(Exx1)*exy1;
beta2 = inv(Exx2)*exy2;
beta3 = inv(Exx3)*exy3;
beta4 = inv(Exx4)*exy4;

 print beta1 beta2 beta3 beta4;

print 'test for equivalence of betas in (15.89):';
 print SSEFyx;
 print SSERyx;
 print SSbtest;
 print Fbtest;
 print pFbtest;

quit;
